
; Loader fuer CPD5

		TITLE	CPD5TST

		.Z80


; ***** Programmbeginn *****





		; Initialisierung der PIOs
		CALL	LINIT



		; initialisieren des Systemregisters 
		LD 	A,D_SYS_IW
		LD	(RAM_SYSREG),A
	




CONIO:

		LD	B,BC_CONIN
		LD	C,0
		LD	D,0
		CALL	UP_Z80CALL


		CP	0
		JR	Z,CONIO

		;

		LD	B,BC_CONOUT
		LD	C,A
		LD	D,0
		CALL	UP_Z80CALL


		JR	CONIO







; Funktion: Ausloesen eines Z80-Calls an den BusController
;
; Aufruf: UP_Z80CALL
; Uebergabeparameter: Register B = MODE
;                     Register C = Parameter1
;                     Register D = Parameter2
; Rueckgabeparameter: keine
; 
UP_Z80CALL:

		; warten, bis alte Anforderungen abgearbeitet wurden
		IN	A,(D_SYS_PORT)
		BIT	BIT_Z80AK,A
		JR	Z,UP_Z80CALL


		LD	A,B
		LD	(RAM_Z80CALL_MD),A
		LD	A,C
		LD	(RAM_Z80CALL_P1),A
		LD	A,D
		LD	(RAM_Z80CALL_P2),A


		; Ausloesen des Z80CALL
		LD	A,(RAM_SYSREG)
		RES	BIT_Z80CALL,A
		OUT	(D_SYS_PORT),A

UP_Z80CALL_A:
		; warten, bis BC den Z80CALL angenommen hat
		IN	A,(D_SYS_PORT)
		BIT	BIT_Z80AK,A
		JR	NZ,UP_Z80CALL_A


		; Zuruecksetzen des Z80CALL 
		LD	A,(RAM_SYSREG)
		SET	BIT_Z80CALL,A
		OUT	(D_SYS_PORT),A


		; Laden des Ergebnisses
		LD	A,(RAM_Z80CALL_P1)


		; Ruecksprung
		RET

































